#!/usr/bin/env bash
set -euo pipefail

FASTCOLL=./bin/md5_fastcoll
OUTDIR=./out
TEMPLATEDIR=./templates

mkdir -p $OUTDIR
head -n 4 $TEMPLATEDIR/ex4.py > $OUTDIR/.ex4.prefix.bin

$FASTCOLL -p $OUTDIR/.ex4.prefix.bin -o $OUTDIR/.ex4.data1.bin $OUTDIR/.ex4.data2.bin

python3 ./replace.py "{GOOD_BIN}" $TEMPLATEDIR/ex4.py $OUTDIR/.ex4.data1.bin $OUTDIR/.ex4-base.py 128

python3 ./replace.py "{BIN}" $OUTDIR/.ex4-base.py $OUTDIR/.ex4.data1.bin $OUTDIR/ex4-good.py 0
python3 ./replace.py "{BIN}" $OUTDIR/.ex4-base.py $OUTDIR/.ex4.data2.bin $OUTDIR/ex4-evil.py 0

chmod +x $OUTDIR/ex4-good.py
chmod +x $OUTDIR/ex4-evil.py

md5sum $OUTDIR/ex4-good.py $OUTDIR/ex4-evil.py

echo "$OUTDIR/ex4-good.py"
$OUTDIR/ex4-good.py

echo "$OUTDIR/ex4-evil.py"
$OUTDIR/ex4-evil.py
