#!/usr/bin/env python3

#Search the pattern given in the first argument
#in the file given in the second argument and replace it with the binary content of the file given in the third argument
#and save the output in the file given in the fourth argument

import re
import sys

def replace_bin(pattern: str, source_file: str, binary_file: str, output_file: str, prefix_size: int):
    # Read the source file
    with open(source_file, 'rb') as file:
        source = file.read()

    # Read the binary file
    with open(binary_file, 'rb') as file:
        data = file.read()

    source = source.split(pattern.encode(), 1)
    with open(output_file, 'wb') as file:
        if prefix_size != 0:
            file.write(source[0])
            data = data[prefix_size:]

        file.write(data)
        file.write(source[1])

if __name__ == "__main__":
    pattern = sys.argv[1]
    source_file = sys.argv[2]
    binary_file = sys.argv[3]
    output_file = sys.argv[4]
    prefix_size = sys.argv[5]

    replace_bin(pattern, source_file, binary_file, output_file, int(prefix_size))
